﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	'Gli elementi presenti sul foglio HTTML vanno dichiarati come JqueryElement
	'Ricordarsi che, mentre su B4J è possibile (anzi, è consigliato) usare il camel case,
	'gli ID degli oggetti HTML devono essere rigorosamente tutti in minuscolo!!!
	
	Private ws As WebSocket
	Private tabProduct, txtProduct, selCat, txtQta, selPack, selVarianti, txtNota, btnAdd, lblAdd As JQueryElement
	Private txtProduct, txtPrezzo, txtPrezzoSconto As JQueryElement
	Private sql As SQL
	Private username As String
	Private TW As TextWriter

End Sub

Public Sub Initialize 'Questo avviene quando viene inizializzato effettivamente il server
	'Avviamo la connessione al DB con UCanAccess
	sql.Initialize("net.ucanaccess.jdbc.UcanaccessDriver", "jdbc:ucanaccess://C:/PelissaM_DB2020.MDB")
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	'Popoliamo il selettore per la categoria merceologica
	Dim sqlq As String = "SELECT DISTINCT Definizione, Codice FROM [TBL_Categorie Merceologiche] WHERE Annulla = 0"
	FillSelectBox(selCat, sql.ExecQuery(sqlq))
	ShowProduct
	username = "pietro 012345"
	Log("Adesso")

End Sub

Private Sub WebSocket_Disconnected

End Sub

Private Sub selCat_Change (Params As Map)
	ShowProduct
End Sub

Private Sub btnAdd_Click (Params As Map)
	Dim codint As String  = sql.ExecQuerySingleResult("SELECT Codint FROM ANG_Prod WHERE ListDesc = '" & txtProduct.GetVal.Value & "'")
	TW.Initialize(File.OpenOutput(File.DirApp, username & ".txt", True))
	TW.WriteLine(codint & "|" & txtQta.GetVal.Value & "|" & selPack.GetVal.Value)
	TW.Close
	' Il TextWriter scrive all'interno di una directory interna al programma.
	' In fase di debug tale directory è la cartella Objects all'interno del progetto B4J
	' Non so ancora quale directory sia una volta che l'eseguibile è compilato del tutto
	' E' però positivo che essendo scritto all'interno del codice non sia visibile (e quindi esplorabile)
	' da chiunque possa accedere al sorgente della pagina
	Dim ordine As List
	ordine.Initialize
	ordine.AddAll(Array As String(txtProduct.GetVal.Value, txtQta.GetVal.Value, selPack.GetVal.Value))
	Dim ordine2 As List
	ordine2.Initialize
	ordine2.Add(ordine)
	TW.Initialize(File.OpenOutput(File.DirApp, "prova1.txt", True))
	TW.WriteList(ordine2)
	TW.Close
	
	ws.RunFunction("swal",Array As Object(CreateMap( _
	"title": txtProduct.GetVal.Value, "text": "Q.ta " & txtQta.GetVal.Value & " con pack da " & selPack.GetVal.Value & " aggiunto all'ordine")))
	btnAdd.RunMethod("hide", Null)
	lblAdd.RunMethod("hide", Null)
	txtQta.SetVal("1")
	selPack.SetVal("6")
End Sub

Private Sub tabProduct_Click (Params As Map)
	btnAdd.RunMethod("show", Null)
	lblAdd.RunMethod("show", Null)
	' Qui usiamo un po' di fantasia
	' I campi di testo nell'editor vengono scritti tramite del javascript posto direttamente dentro al file HTML
	' Ogniqualvolta clicchiamo sulla tabella (in qualunque punto) il codice va a leggere il prezzo che viene riportato 
	' nel textbox e lo manipola per stampare lo sconto nel secondo textbox
	Dim p As String = txtPrezzo.GetVal.Value
	Dim prezzo As Double = p.SubString(2)
	Dim prezzosconto As Double = (prezzo - (prezzo*10/100))
	txtPrezzoSconto.SetVal("€ " & NumberFormat2(prezzosconto,1,2,2,False))
	txtQta.SetVal("1")
	selPack.SetVal("6")
End Sub


Sub ShowProduct 'Riempie la tabella dei prodotti
	Dim f As Future = selCat.GetVal
	Dim CatMerc As String = f.Value
	FillTable(tabProduct, sql.ExecQuery("Select Desc, Listino FROM ANG_Prod As T1 LEFT JOIN ANG_List As T2 ON T1.CodInt = T2.Prod WHERE CatMerc = " _
	& CatMerc & " AND Annul = False AND T2.Fascia = 28"))

End Sub

Sub FillTable(jq As JQueryElement, rs As ResultSet) 'Popola una datatable con gli elementi di una query SQL
	Dim data As List
	data.Initialize
	Do While rs.NextRow
		Dim row As List
		row.Initialize
		For a = 0 To rs.ColumnCount - 1
			Dim val As String = rs.GetString2(a)
			Select a
				Case 0
					row.Add(val)
				Case 1
					Dim prezzo As Float = val
					Dim prezzoeuro As String = "€ " & NumberFormat2(prezzo, 1, 2,2,False)
					row.Add(prezzoeuro)	
			End Select
		Next
		data.Add(row)
	Loop
	rs.Close
	jq.RunMethod("dataTable", Array As Object(CreateMap("aaData": data, "bDestroy": True, "bFilter": True, _
	"bPaginate": False, "sScrollY": "200px", "bSort": False, "bInfo": False)))
End Sub

Sub FillSelectBox (jq As JQueryElement, rs As ResultSet)
	'Popola il selettore della categoria merceologica
	'impostando come Value il codice della categoria
	'e come descrizione il nome della categoria
	'es: <option value="6=>CICLAMINO</option>
	
	Dim sb As StringBuilder
	sb.Initialize
	Do While rs.NextRow
		Dim val As Int = WebUtils.EscapeHtml(rs.GetInt2(1))
		Dim def As String = WebUtils.EscapeHtml(rs.GetString2(0))
		sb.Append("<option value='").Append(val).Append("'>").Append(def).Append("</option>")
	Loop
	rs.Close
	jq.SetHtml(sb.ToString)
End Sub