﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
' Gli elementi presenti sul foglio HTTML vanno dichiarati come JqueryElement
' Ricordarsi che, mentre su B4J è possibile (anzi, è consigliato) usare il camel case,
' gli ID degli oggetti HTML devono essere rigorosamente tutti in minuscolo!!!
	
	Private ws As WebSocket
	Private tabProduct, txtProduct, selCat, txtQta, selPack, selVarianti, btnAdd, lblAdd, tmpPrezzo As JQueryElement
	Private txtProduct, txtPrezzo, txtPrezzoSconto, lblSconto As JQueryElement
	Private sql As SQL
	Private ListaOrdine As List
	Private StampaOrdine As List
	Private sconto As String
	
End Sub

Public Sub Initialize 'Questo avviene quando viene inizializzato effettivamente il server
' Avviamo la connessione al DB con UCanAccess
	sql.Initialize("net.ucanaccess.jdbc.UcanaccessDriver", $"jdbc:ucanaccess://${Main.DBPath}"$)
	ListaOrdine.Initialize
	StampaOrdine.Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	lblSconto.RunMethod("hide", Null)
	txtPrezzoSconto.RunMethod("hide", Null)
	If ws.Session.GetAttribute("username") == Null Then
		WebUtils.RedirectTo(ws, "/index.html")
	End If
' Popoliamo il selettore per la categoria merceologica
	Dim sqlq As String = "SELECT DISTINCT Definizione, Codice FROM [TBL_Categorie Merceologiche] WHERE Annulla = 0"
	WebUtils.FillSelectBox(selCat, sql.ExecQuery(sqlq))
	
' Popoliamo il selettore per le varianti
	Dim sqlq2 As String = "SELECT DISTINCT Definizione, Codice FROM [TBL_VARIANTI COMANDA] WHERE Annulla = 0"
	WebUtils.FillSelectBox2(selVarianti, sql.ExecQuery(sqlq2))
' Creiamo la tabella prodotti
	ShowProduct
	
	If ws.Session.GetAttribute("ordine") == Null Then
		ListaOrdine.Initialize
		StampaOrdine.Initialize
	Else
		ListaOrdine = ws.Session.GetAttribute("ordine")
		StampaOrdine = ws.Session.GetAttribute("stampaOrdine")
	End If

End Sub

Private Sub WebSocket_Disconnected

End Sub

Private Sub selCat_Change (Params As Map)
	ShowProduct
	
End Sub

Private Sub btnAdd_Click (Params As Map)
	Dim f1 As Future = selVarianti.GetVal
	If f1.Value == "99" Then
		Dim codvariante As String = "null"
		Dim variante As String = "Nessuna Variante"
		Else
		Dim codvariante As String = f1.Value
		Dim variante As String = sql.ExecQuerySingleResult2("SELECT DISTINCT Definizione FROM [TBL_Varianti Comanda] WHERE Codice = ?", Array As String(f1.Value))
	End If
	Dim totprezzo As String
	If sconto == Null Then
		Dim f2 As Future = txtPrezzo.GetVal
		totprezzo = f2.Value
		Else
			Dim f3 As Future = txtPrezzoSconto.GetVal
			totprezzo = f3.Value
	End If
	
	Dim productFut As Future = txtProduct.GetVal
	Dim qtaFut As Future = txtQta.GetVal
	Dim packFut As Future = selPack.GetVal
	
	Dim prodotto As String = productFut.Value
	Dim qta As String = qtaFut.Value
	Dim pack As String = packFut.Value
	

' Genero la lista che servirà per l'output corretto della tabella HTML
	Dim ordine As List
	ordine.Initialize
	ordine.AddAll(Array As String(prodotto, variante, pack, qta, totprezzo))
	ListaOrdine.Add(ordine)

' Genero la lista che servirà per il format di stampa corretta
	Dim codint As String  = sql.ExecQuerySingleResult2("SELECT Codint FROM ANG_Prod WHERE Desc = ?", Array As String(prodotto))
	Dim tmp() As String = Array As String(prodotto, codint, qta, pack, codvariante)
	Dim P As String = WebUtils.ArrayToString(tmp)
	Dim ordine2 As List
	ordine2.Initialize
	ordine2.Add(P)
	StampaOrdine.AddAll(ordine2)

	ws.RunFunction("swal",Array As Object(CreateMap( _
		"title": prodotto, "text": $"Q.tà ${qta} con pack da ${pack} aggiunto al Carrello Ordini"$)))
		
	ws.Session.SetAttribute("ordine", ListaOrdine)
	ws.Session.SetAttribute("stampaOrdine", StampaOrdine)
	
End Sub

Private Sub tabProduct_Click (Params As Map)
	Dim f As Future = tmpPrezzo.GetVal
	txtPrezzo.SetVal(f.Value)
	CalcolaSconto
	
	txtQta.SetVal("1")
	selPack.SetVal("6")
	selVarianti.SetVal("99")
	
End Sub

Private Sub txtQta_Change (Params As Map)
	Dim f As Future = tmpPrezzo.GetVal
	If f.Value <> "" Then
		Dim p As String = f.Value
		Dim qtaFut As Future = txtQta.GetVal
		Dim qta As Int = qtaFut.Value
		Dim prezzo As Double = p.SubString(2) * qta
		Dim prezzoeuro As String = "€ " & NumberFormat2(prezzo, 1, 2,2,False)
		txtPrezzo.SetVal(prezzoeuro)
		CalcolaSconto
	End If
	
End Sub


Sub CalcolaSconto
	Dim f As Future = txtPrezzo.GetVal
	Dim p As String = f.Value
	Dim prezzo As Double = p.SubString(2)
	sconto = sql.ExecQuerySingleResult2("SELECT Sc1 FROM ANG_SCONTI WHERE Sogg = ?", Array As String(ws.Session.GetAttribute("codice")))
	If sconto == Null Then
		lblSconto.RunMethod("hide", Null)
		txtPrezzoSconto.RunMethod("hide", Null)
	Else
		Dim percsconto As Int = sconto
		Dim prezzosconto As Double = (prezzo - (prezzo * percsconto/100))
		txtPrezzoSconto.SetVal("€ " & NumberFormat2(prezzosconto,1,2,2,False))
		lblSconto.RunMethod("show", Null)
		txtPrezzoSconto.RunMethod("show", Null)
	End If

End Sub

Sub ShowProduct 'Riempie la tabella dei prodotti
	Dim f As Future = selCat.GetVal
	WebUtils.FillTable(tabProduct, sql.ExecQuery2( _
	"SELECT Desc, Listino FROM ANG_Prod As T1 LEFT JOIN ANG_List As T2 ON T1.CodInt = T2.Prod WHERE CatMerc = ? AND Annul = False AND T2.Fascia = 28", _
	 Array As String(f.Value)))

' Con le seguenti righe resettiamo l'editor di modo che ogni volta che spostiamo il focus del mouse
' dalla tabella ad un altro oggetto e non c'è nessuna riga selezionata
' impediamo che l'utente possa inserire nell'ordine una stringa vuota
	btnAdd.RunMethod("hide", Null)
	lblAdd.RunMethod("hide", Null)
	txtQta.SetVal("1")
	selPack.SetVal("6")
	selVarianti.SetVal("99")
	
End Sub