﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.5
@EndOfDesignText@
'version 1.00
Sub Process_Globals
	Public bc As ByteConverter
End Sub

Public Sub init
	bc.LittleEndian = True
End Sub
#Region Test



Public Sub EscapeHtml(Raw As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	For i = 0 To Raw.Length - 1
		Dim C As Char = Raw.CharAt(i)
		Select C
			Case QUOTE
				sb.Append("&quot;")
			Case "'"
				sb.Append("&#39;")
			Case "<"
				sb.Append("&lt;")
			Case ">"
				sb.Append("&gt;")
			Case "&"
				sb.Append("&amp;")
			Case Else
				sb.Append(C)
		End Select
	Next
	Return sb.ToString
End Sub

Public Sub ReplaceMap(Base As String, Replacements As Map) As String
	Dim pattern As StringBuilder
	pattern.Initialize
	For Each k As String In Replacements.Keys
		If pattern.Length > 0 Then pattern.Append("|")
		pattern.Append("\$").Append(k).Append("\$")
	Next
	Dim m As Matcher = Regex.Matcher(pattern.ToString, Base)
	Dim result As StringBuilder
	result.Initialize
	Dim lastIndex As Int
	Do While m.Find
		result.Append(Base.SubString2(lastIndex, m.GetStart(0)))
		Dim replace As String = Replacements.Get(m.Match.SubString2(1, m.Match.Length - 1))
		If m.Match.ToLowerCase.StartsWith("$h_") Then replace = EscapeHtml(replace)
		result.Append(replace)
		lastIndex = m.GetEnd(0)
	Loop
	If lastIndex < Base.Length Then result.Append(Base.SubString(lastIndex))
	Return result.ToString
End Sub

Public Sub RedirectTo(ws As WebSocket, TargetUrl As String)
	ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))
End Sub

Public Sub ReadString(In As InputStream) As String
	Dim len As Int = bc.IntsFromBytes(ReadBytesFromStream(In, 4))(0)
	Return BytesToString(ReadBytesFromStream(In, len), 0, len, "UTF8")
End Sub

#End Region

Sub ReadBytesFromStream(In As InputStream, Length As Int) As Byte()
	If Length > 5000 Then
		Log("Error reading from stream")
		Return Null
	End If
	Dim b(Length) As Byte
	Dim count As Int = 0
	Do While count < Length
		Dim read As Int = In.ReadBytes(b, count, Length - count)
		If read <= 0 Then
			Log("Error reading from stream.")
			Return Null
		End If
		count = count + read
	Loop
	Return b
End Sub

Sub FillTable(jq As JQueryElement, rs As ResultSet) 'Popola una datatable con gli elementi di una query SQL
	Dim data As List
	data.Initialize
	Do While rs.NextRow
		Dim row As List
		row.Initialize
		For a = 0 To rs.ColumnCount - 1
			Dim val As String = rs.GetString2(a)
			Select a
				Case 0
					row.Add(val)
				Case 1
					Dim prezzo As Float = val
					Dim prezzoeuro As String = "€ " & NumberFormat2(prezzo, 1, 2,2,False)
					row.Add(prezzoeuro)
			End Select
		Next
		data.Add(row)
	Loop
	rs.Close
	Dim ItaLang As Map = CreateMap( _
	"sEmptyTable":     "Nessun dato presente nella tabella", _
	"sInfo":           "Vista da _START_ a _END_ di _TOTAL_ elementi", _
	"sInfoEmpty":      "Vista da 0 a 0 di 0 elementi", _
	"sInfoFiltered":   "(filtrati da _MAX_ elementi totali)", _
	"sInfoPostFix":    "", _
	"sInfoThousands":  ".", _
	"sLengthMenu":     "Visualizza _MENU_ elementi", _
	"sLoadingRecords": "Caricamento...", _
	"sProcessing":     "Elaborazione...", _
	"sSearch":         "Cerca:", _
	"sZeroRecords":    "La ricerca non ha portato alcun risultato.")
	jq.RunMethod("dataTable", Array As Object(CreateMap("aaData": data, "bDestroy": True, "bFilter": True, _
	"bPaginate": False, "sScrollY": "200px", "bSort": False, "bInfo": False, "language": ItaLang)))
End Sub

Sub FillSelectBox (jq As JQueryElement, rs As ResultSet)
	'Popola il selettore della categoria merceologica
	'impostando come Value il codice della categoria
	'e come descrizione il nome della categoria
	'es: <option value="6">CICLAMINO</option>
	
	Dim sb As StringBuilder
	sb.Initialize
	Do While rs.NextRow
		Dim val As Int = EscapeHtml(rs.GetInt2(1))
		Dim def As String = EscapeHtml(rs.GetString2(0))
		sb.Append("<option value='").Append(val).Append("'>").Append(def).Append("</option>")
	Loop
	rs.Close
	jq.SetHtml(sb.ToString)
End Sub

Sub FillSelectBox2 (jq As JQueryElement, rs As ResultSet)
	'Popola il selettore dele varianti
	'impostando come Value il codice della varinte
	'e come descrizione il nome della variante
	'es: <option value="88">ETICHETTA</option>
	
	Dim sb As StringBuilder
	sb.Initialize
	Do While rs.NextRow
		Dim val As Int = EscapeHtml(rs.GetInt2(1))
		Dim def As String = EscapeHtml(rs.GetString2(0))
		sb.Append("<option value='").Append(val).Append("'>").Append(def).Append("</option>")
	Loop
	sb.Append("<option value='99'>Nessuna Variante</option>")
	rs.Close
	jq.SetHtml(sb.ToString)
End Sub

Sub ArrayToString (locArray() As String) As String
	Dim OneString As String
	If locArray.Length=0 Then Return ""
	If locArray.Length=1 Then Return locArray(0)
	OneString=locArray(0)
	For i=1 To locArray.Length-1
		OneString=OneString & "|" & locArray(i)
	Next
	Return OneString
End Sub


Sub StringToArray (OneString As String ) As String()
	Dim locArray() As String
	If OneString.Contains("|")=True Then
		locArray=Regex.Split("\|",OneString)
	Else
		locArray= Array As String(OneString)
	End If
	Return locArray
End Sub